////////////////////////////////////////////////////////////////////////////////
//! \file   CommonUI.hpp
//! \brief  Wrapper to include the most common UI class headers.
//! \author Chris Oldwood

// Check for previous inclusion
#ifndef WCL_COMMONUI_HPP
#define WCL_COMMONUI_HPP

#if _MSC_VER > 1000
#pragma once
#endif

////////////////////////////////////////////////////////////////////////////////
// System headers.

#include <Core/Common.hpp>		// Core library common headers.
#include <WCL/Common.hpp>		// Windows C++ library common headers.

////////////////////////////////////////////////////////////////////////////////
// Library headers.

// Container windows.
#include <WCL/Dialog.hpp>
#include <WCL/PropertyPage.hpp>

// Controls.
#include <WCL/Button.hpp>
#include <WCL/CheckBox.hpp>
#include <WCL/CheckBoxList.hpp>
#include <WCL/ComboBox.hpp>
#include <WCL/DateTimePicker.hpp>
#include <WCL/DecimalBox.hpp>
#include <WCL/EditBox.hpp>
#include <WCL/IconCtrl.hpp>
#include <WCL/Label.hpp>
#include <WCL/ListBox.hpp>
#include <WCL/ListView.hpp>
#include <WCL/ProgressBar.hpp>
#include <WCL/RadioBtn.hpp>
#include <WCL/TabCtrl.hpp>
#include <WCL/URLLabel.hpp>

#endif // WCL_COMMONUI_HPP
